import bpy
import random

spacing = 2
cSize = .5
mStep = 2
sX = 15
sY = 15
sZ = 15
mMatrix = []

def desenho():
    initializeMatrix(17)
    mMatrix[sX][sY][sZ] = 1
    recursive(sX,sY,sZ)    
    for i in range(len(mMatrix)):
        for j in range(len(mMatrix)):
            for k in range(len(mMatrix)):
                if mMatrix[i][j][k] != 0:
                    px = i*cSize*spacing
                    py = j*cSize*spacing
                    pz = k*cSize*spacing
                    #print(px,py,pz)
                    bpy.ops.mesh.primitive_cube_add(radius=cSize,location=(px-2.5,py-2.5,pz-2.5))
    mMatrix[sX][sY][sZ] = 2

def initializeMatrix(size):
    for i in range(size):
        slice = []
        for j in range(size):
            slice.append( [0 for j in range(size)] )
        mMatrix.append(slice)
        
def recursive(r,c,d):
    randomDirs = [1,2,3,4,5,6]
    mSize = [len(mMatrix), len(mMatrix), len(mMatrix)]
    random.shuffle(randomDirs)
    #Examine each direction
    test = 0
    for direction in randomDirs: 
        if direction == 1: # Up
            #Whether 2 cells up is out or not
            if r - mStep <= mStep:
                test+=1
                continue
            if mMatrix[r - mStep][c][d] == 0:
                for i1 in range(1, mStep+1):
                    mMatrix[r-i1][c][d] = 1
                recursive(r - mStep, c, d)
            else: 
                test+=1
            #break
        elif direction == 2: # Right
            #Whether 2 cells to the right is out or not
            if c + mStep >= mSize[0] - mStep:
                test+=1
                continue
            if mMatrix[r][c + mStep][d] == 0:
                for i2 in range(1, mStep+1):
                    mMatrix[r][c+i2][d] = 1;
                recursive(r, c + mStep, d)
            else:
                test+=1
            #break
        elif direction == 3: # Down
            # Whether 2 cells down is out or not
            if r + mStep >= mSize[1] - mStep:
                test+=1
                continue
            if mMatrix[r + mStep][c][d] == 0:
                for i3 in range(1, mStep+1):
                    mMatrix[r+i3][c][d] = 1
                recursive(r + mStep, c, d)
            else:
                test+=1
            #break
        elif direction == 4: #Left
            # Whether 2 cells to the left is out or not
            if c - mStep <= mStep:
                test+=1
                continue
            if mMatrix[r][c - mStep][d] == 0:
               for i4 in range(1, mStep+1):
                    mMatrix[r][c-i4][d] = 1
               recursive(r, c - mStep, d)
            else:
               test+=1
            #break
        elif direction == 5: #Up
            # Whether 2 cells to the left is out or not
            if d - mStep <= mStep:
                test+=1
                continue
            if mMatrix[r][c][d - mStep] == 0:
               for i5 in range(1, mStep+1):
                    mMatrix[r][c][d-i5] = 1
               recursive(r, c, d - mStep)
            else:
               test+=1
        elif direction == 6: #Down
            # Whether 2 cells to the left is out or not
            if d + mStep >= mStep:
                test+=1
                continue
            if mMatrix[r][c][d + mStep] == 0:
               for i6 in range(1, mStep+1):
                    mMatrix[r][c][d+i6] = 1
               recursive(r, c, d + mStep)
            else:
               test+=1
            #break        
    if test == 4: 
        mMatrix[r][c][d] = 3
    if test == 2:
        mMatrix[r][c][d] = 4
            
            
            
desenho()